package es.ucm.fdi.grasia.faerie.demos.teacherFinding.timetableUpdater;

import java.util.Properties;

import org.apache.felix.scr.annotations.Component;

import es.ucm.fdi.grasia.faerie.core.AbstractAttributeUpdaterComponent;
import es.ucm.fdi.grasia.faerie.core.Attribute;
import es.ucm.fdi.grasia.faerie.core.ContextEvent;
import es.ucm.fdi.grasia.faerie.core.ContextValue;
import es.ucm.fdi.grasia.faerie.core.ContextObserver;
import es.ucm.fdi.grasia.faerie.core.model.BasicContextValue;
import es.ucm.fdi.grasia.faerie.core.util.Functions;
import es.ucm.fdi.grasia.faerie.demos.teacherFinding.model.Timetable;

@Component(inherit = true)
@SuppressWarnings({ "unchecked", "rawtypes" })
public class TimetableUpdater extends AbstractAttributeUpdaterComponent {

	@Override
	public int handle(ContextEvent event) {
		return Functions.contextElementAddedOrRemoved(Timetable.class.getName(), event) ? ContextObserver.HANDLE_WRITE
				: ContextObserver.HANDLE_NONE;
	}

	@Override
	public void elementAdded(Attribute attributeInstance, ContextEvent event) {
		this.putUpdatedAttributeInstance(attributeInstance);

		Properties properties = Functions.obtainProperties(attributeInstance.getEntity().getName()
				+ "_timetable.properties");
		ContextValue<Properties> value = new BasicContextValue(properties, 100.0, this.getBundleEntity());

		attributeInstance.update(value);
	}
}
